VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5940
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5940
   ScaleWidth      =   6690
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   2535
      Left            =   360
      TabIndex        =   2
      Top             =   3120
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   4471
      _Version        =   393217
      TextRTF         =   $"KBDebug.frx":0000
   End
   Begin VB.Timer Timer1 
      Left            =   6360
      Top             =   3720
   End
   Begin VB.TextBox Text1 
      Height          =   2055
      Left            =   360
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   840
      Width           =   6015
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   120
      Width           =   6135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' Declare
Option Explicit
'*****************
' *Keyboard Locale Info*  by Chris
'   reports the current keyboard locale for any thread in your application workspace
'   (a keyboard "thread" basically means a control on any form)
 '++ This code emulates the Keyboard Indicator on the TaskBar (tray), but is better:
' 1) It gives a full and more descriptive locale than the indicator,
'    which shows mostly a cryptic symbol like "EN" - English (US)
' 2) You don't have to show the keyboard indicator (optional)
' 3) Your Taskbar can be on "Auto Hide", so you may not be able to see it
' 4) Occasional glitches with the indicator don't always report
'    and change the keyboard properly
'---------------
' Code Requirements:  Add a label and timer
' To Test:  a) Add a text box, a richtext box, and any other control (like a grid)
'           b) Control Panel > Keyboard > Language tab:
'              ... add as many languages as you want
' Tip:  To switch languages faster, use the keyboard shortcut:
'       ... the default shortcut is <Left Alt>+<Shift>
'---------------
' Note:  This code has been tested on Win95 and Win98, but not NT
'  - you may need to make a few adjustments or hacks to make it work on NT
'  - also a keyboard thread is suppose to work a little differently on NT?
'*****************
Private Declare Function GetLocaleInfo& Lib "KERNEL32" Alias "GetLocaleInfoA" (ByVal Locale&, _
 ByVal LCType&, ByVal lpLCData$, ByVal cchData&) ' ANSI version
Private Const LOCALE_SLANGUAGE& = &H2 '  localized name of language

Private Declare Function GetKeyboardLayout& Lib "USER32" (ByVal dwLayout&) ' not NT?
Private Const DWL_ANYTHREAD& = 0 ' or pass the thread you want to test for

Private Declare Function GetKeyNameText& Lib "USER32" Alias "GetKeyNameTextA" (ByVal lParam&, _
 ByVal lpBuffer$, ByVal nSize&) ' ANSI version
Private Declare Function MapVirtualKeyEx& Lib "USER32" Alias "MapVirtualKeyExA" (ByVal Ucode&, _
 ByVal uMapType&, ByVal dwhkl&) ' ANSI version

Private KBLayout& ' track current
Private Const bufsize = 256 ' for API string handling

Private Sub KeyBoardName(ByVal VirtualKey&)
    ' a debug routine
    Debug.Print "Virtual Key = " & VirtualKey
    Dim ScanCode&, r&, strng$
    r = MapVirtualKeyEx(CLng(VirtualKey), 0&, KBLayout)
    Debug.Print "Scan Code = " & r
    'THESE KEYS DON'T SCAN RIGHT, SO INTERVENE
    ' NOTE: some other keys don't scan right either!
    ' (a better way to do this!?)
    ''' if you get this routine working 100%,
    ''' mailto:Chris@Provider-Services.com (thanks!)
    Select Case VirtualKey
        Case vbKeyPause
          ScanCode = 69
        Case vbKeyNumlock
          ScanCode = 325
        Case vbKeySnapshot 'Print Screen
          ScanCode = 257
        Case vbKeyDivide ' NUM /
          ScanCode = 309
    End Select
    If ScanCode <> 0 Then
        Debug.Print "Corrected Scan Code = " & ScanCode
    Else
        ScanCode = r
    End If
    Dim buffer As String * bufsize
    'shift scancode
    ScanCode = CLng(Val("&H" & Hex(ScanCode) & "0000"))
    r = GetKeyNameText(ScanCode, buffer, bufsize - 1)
    If r > 0 Then ' anything returned?
        strng = Left$(buffer, r)
        Debug.Print "Key Name = <" & strng & ">"
    End If
    Debug.Print 'blank line
End Sub

Private Sub Form_Load()
    ' skip this if you have it designed already
    KeyPreview = True 'intercept
    With Label1
     .BackStyle = 1 '0 'opaque
     .BackColor = vbBlack
     .ForeColor = vbGreen
     .FontBold = True
    End With
    Timer1.Interval = 100
    Timer1.Enabled = True
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    Debug.Print "Key ASCII = " & KeyAscii & " """ & Chr(KeyAscii) & """"
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    KeyBoardName KeyCode
    ' optionally put this code in Key_Down()?
End Sub

Private Sub Timer1_Timer()
    ' Display KeyBoard Locale
    ' (this is great code to put on a status bar!)
    Dim r&
    r = GetKeyboardLayout(DWL_ANYTHREAD) '0&
    If r <> KBLayout Then
        KBLayout = r
        r = Val("&H" & Right(Hex(r), 4)) ' lower 16bits
        Dim strng$, buffer As String * bufsize
        r = GetLocaleInfo(r, LOCALE_SLANGUAGE, buffer, bufsize - 1)
        strng = buffer
        If Label1.Caption <> strng Then
            Label1.Caption = strng
        End If
    End If
End Sub


